"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Api = void 0;
const utils_1 = require("@ztimson/utils");
class Api extends utils_1.Http {
    url;
    opts;
    emitter = new utils_1.TypedEmitter();
    _token = null;
    get token() { return this._token; }
    set token(token) {
        if (token == this._token)
            return;
        this._token = token;
        this.headers['Authorization'] = token ? `Bearer ${token}` : undefined;
        this.emit('TOKEN', token);
    }
    constructor(url = location.origin, opts = {}) {
        opts.url = url;
        super(opts);
        this.url = url;
        this.opts = opts;
    }
    emit = this.emitter.emit.bind(this.emitter);
    off = this.emitter.off.bind(this.emitter);
    on = this.emitter.on.bind(this.emitter);
    once = this.emitter.once.bind(this.emitter);
    request(options) {
        const req = super.request(options)
            .then(resp => {
            this.emit('RESPONSE', resp, options);
            return resp;
        }).catch(err => {
            const e = err?.data || err;
            this.emit('REJECTED', e, options);
            throw e;
        });
        this.emit('REQUEST', req, options);
        return req;
    }
}
exports.Api = Api;
