"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Groups = void 0;
const api_1 = require("./api");
const utils_1 = require("@ztimson/utils");
class Groups extends utils_1.TypedEmitter {
    api;
    constructor(api) {
        super();
        this.api = typeof api == 'string' ? new api_1.Api(api) : api;
    }
    create(group) {
        return this.api.request({
            url: `/api/groups/${group.name}`,
            method: 'POST',
            body: group
        }).then(resp => {
            this.emit('CREATE', resp.data);
            return resp.data;
        });
    }
    list() {
        return this.api.request({ url: `/api/groups` }).then(resp => {
            this.emit('LIST', resp.data || []);
            return resp.data;
        });
    }
    read(name) {
        return this.api.request({ url: `/api/groups/${name}` }).then(resp => {
            this.emit('READ', resp.data);
            return resp.data;
        });
    }
    update(group) {
        return this.api.request({
            url: `/api/groups/${group.name}`,
            method: 'PATCH',
            body: group
        }).then(resp => {
            this.emit('UPDATE', resp.data);
            return resp.data;
        });
    }
    delete(name) {
        return this.api.request({
            url: `/api/groups/${name}`,
            method: 'DELETE'
        }).then(() => this.emit('DELETE', name));
    }
}
exports.Groups = Groups;
